



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>javascript prototype学习</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">javascript prototype学习</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:23:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">function foo(a, b, c)<br />
{<br />
　　return a*b*c;<br />
}<br />
alert(foo.length);<br />
alert(typeof foo.constructor);<br />
alert(typeof foo.call);<br />
alert(typeof foo.apply);<br />
alert(typeof foo.prototype);
</pre>
</div>
<p>对于上面的代码,用浏览器运行后你会发现:</p>
<ol><li>length: 提供的是函数的参数个数</li>
<li>prototype: 是一个object</li>
<li>其它三个都是function</li></ol>
<p>而对于任何一个函数的声明,它都将会具有上面所述的5个property(方法或者属性).</p>
<p>用过JavaScript的同学们肯定都对prototype如雷贯耳，但是这究竟是个什么东西却让初学者莫衷一是，只知道函数都会有一个prototype属性，可以为其添加函数供实例访问，其它的就不清楚了，最近看了一些 JavaScript高级程序设计，终于揭开了其神秘面纱。</p>
<p>每个函数都有一个prototype属性，这个属性是指向一个对象的引用，这个对象称为原型对象，原型对象包含函数实例共享的方法和属性，也就是说将函数用作构造函数调用（使用new操作符调用）的时候，新创建的对象会从原型对象上继承属性和方法。</p>
<h3>私有变量、函数</h3>
<p>在具体说prototype前说几个相关的东东，可以更好的理解prototype的设计意图。之前写的一篇<a href="http://www.cnblogs.com/dolphinX/p/3269145.html" rel="external nofollow noreferrer">JavaScript 命名空间</a>博客提到过JavaScript的函数作用域，在函数内定义的变量和函数如果不对外提供接口，那么外部将无法访问到，也就是变为私有变量和私有函数。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Obj(){<br />
                var a=0; //私有变量<br />
                var fn=function(){ //私有函数

                }<br />
            }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>这样在函数对象Obj外部无法访问变量a和函数fn，它们就变成私有的，只能在Obj内部使用，即使是函数Obj的实例仍然无法访问这些变量和函数</p>
<div>
<pre class="prettyprint linenums">var o=new Obj();<br />
            console.log(o.a); //undefined<br />
            console.log(o.fn); //undefined</pre>
</div>
<h3>静态变量、函数</h3>
<p>当定义一个函数后通过 &ldquo;.&rdquo;为其添加的属性和函数，通过对象本身仍然可以访问得到，但是其实例却访问不到，这样的变量和函数分别被称为静态变量和静态函数，用过Java、C#的同学很好理解静态的含义。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Obj(){

            }

            Obj.a=0; //静态变量

            Obj.fn=function(){ //静态函数

            }

            console.log(Obj.a); //0<br />
            console.log(typeof Obj.fn); //function

            var o=new Obj();<br />
            console.log(o.a); //undefined<br />
            console.log(typeof o.fn); //undefined</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>实例变量、函数</h3>
<p>在面向对象编程中除了一些库函数我们还是希望在对象定义的时候同时定义一些属性和方法，实例化后可以访问，JavaScript也能做到这样</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Obj(){<br />
                this.a=[]; //实例变量<br />
                this.fn=function(){ //实例方法

                }<br />
            }

            console.log(typeof Obj.a); //undefined<br />
            console.log(typeof Obj.fn); //undefined

            var o=new Obj();<br />
            console.log(typeof o.a); //object<br />
            console.log(typeof o.fn); //function</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>这样可以达到上述目的，然而</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Obj(){<br />
                this.a=[]; //实例变量<br />
                this.fn=function(){ //实例方法

                }<br />
            }

            var o1=new Obj();<br />
            o1.a.push(1);<br />
            o1.fn={};<br />
            console.log(o1.a); //[1]<br />
            console.log(typeof o1.fn); //object<br />
            var o2=new Obj();<br />
            console.log(o2.a); //[]<br />
            console.log(typeof o2.fn); //function</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>上面的代码运行结果完全符合预期，但同时也说明一个问题，在o1中修改了a和fn，而在o2中没有改变，由于数组和函数都是对象，是引用类型，这就说明o1中的属性和方法与o2中的属性与方法虽然同名但却不是一个引用，而是对Obj对象定义的属性和方法的一个复制。</p>
<p>这个对属性来说没有什么问题，但是对于方法来说问题就很大了，因为方法都是在做完全一样的功能，但是却又两份复制，如果一个函数对象有上千和实例方法，那么它的每个实例都要保持一份上千个方法的复制，这显然是不科学的，这可肿么办呢，prototype应运而生。</p>
<h3>prototype</h3>
<p>无论什么时候，只要创建了一个新函数，就会根据一组特定的规则为该函数创建一个prototype属性，默认情况下prototype属性会默认获得一个constructor(构造函数)属性，这个属性是一个指向prototype属性<strong>所在函数</strong>的指针，有些绕了啊，写代码、上图！</p>
<div>
<pre class="prettyprint linenums">function Person(){

            }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/349217/201308/27224136-4b97c5495fe64f46abddc78f50cb8097.png" /></p>
<p>根据上图可以看出Person对象会自动获得prototyp属性，而prototype也是一个对象，会自动获得一个constructor属性，该属性正是指向Person对象。</p>
<p>当调用构造函数创建一个实例的时候，实例内部将包含一个内部指针（很多浏览器这个指针名字为__proto__）指向构造函数的prototype，这个连接存在于实例和构造函数的prototype之间，而不是实例与构造函数之间。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Person(name){<br />
                this.name=name;<br />
            }

            Person.prototype.printName=function(){<br />
                alert(this.name);<br />
            }

            var person1=new Person('Byron');<br />
            var person2=new Person('Frank');</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/349217/201308/27224146-31fb37b7c1d0485eaf25500b30fe739e.png" /></p>
<p>Person的实例person1中包含了name属性，同时自动生成一个__proto__属性，该属性指向Person的prototype，可以访问到prototype内定义的printName方法，大概就是这个样子的</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/349217/201308/27224151-5a1aff0645604df58e40abc919bc836d.png" /></p>
<p>写段程序测试一下看看prototype内属性、方法是能够共享</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Person(name){<br />
                this.name=name;<br />
            }

            Person.prototype.share=[];

            Person.prototype.printName=function(){<br />
                alert(this.name);<br />
            }

            var person1=new Person('Byron');<br />
            var person2=new Person('Frank');

            person1.share.push(1);<br />
            person2.share.push(2);<br />
            console.log(person2.share); //[1,2]</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>果不其然！实际上当代码读取某个对象的某个属性的时候，都会执行一遍搜索，目标是具有给定名字的属性，搜索首先从对象实例开始，如果在实例中找到该属性则返回，如果没有则查找prototype，如果还是没有找到则继续递归prototype的prototype对象，直到找到为止，如果递归到object仍然没有则返回错误。同样道理如果在实例中定义如prototype同名的属性或函数，则会覆盖prototype的属性或函数。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Person(name){<br />
                this.name=name;<br />
            }

            Person.prototype.share=[];

            var person=new Person('Byron');<br />
            person.share=0;

            console.log(person.share); //0而不是prototype中的[]</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h3>构造简单对象</h3>
<p>当然prototype不是专门为解决上面问题而定义的，但是却解决了上面问题。了解了这些知识就可以构建一个科学些的、复用率高的对象，如果希望实例对象的属性或函数则定义到prototype中，如果希望每个实例单独拥有的属性或方法则定义到this中，可以通过构造函数传递实例化参数。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">function Person(name){<br />
                this.name=name;<br />
            }

            Person.prototype.share=[];

            Person.prototype.printName=function(){<br />
                alert(this.name);<br />
            }</pre>
<div>&nbsp;</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvd3vxq.html">OC编程之道-创建对象之工厂方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvzdoo9.html">XDebug 自动开启PHP Stack Trace&comma; 导致PHP Log 超1G</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld3pk9.html">uva10106（大数乘法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zyxvq.html">RPC应用的java实现&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ez16z8.html">linux内核更新前后配置文件的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7vd5q.html">Linux   磁盘的组成</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmmvnz9.html">【转载】如何在德州仪器网站查找和下载PCB封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn21rrq.html">对Native App与Web App的一些思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/96owrey9.html">学习JAVA第一部分总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x243v8.html">Android窗口管理服务WindowManagerService对窗口的组织方式分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14mvjq.html">部署LNMP架构Blog博客平台 ---惟净</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjryl38.html">Akka（5）： ConsistentHashing Router - 可选定Routee的任务分配模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgo0xr8.html">bzoj 3223&colon; Tyvj 1729 文艺平衡树 &lpar;splay）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ze41j9.html">&lbrack;LeetCode&rsqb; Minimum Swaps To Make Sequences Increasing 使得序列递增的最小交换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3vwr9.html">Html转义字符列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4rylj9.html">Activity中满屏和去标题的实现方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1lzy5q.html">C语言中const关键字的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rdj258.html">&lbrack;Hadoop异常处理&rsqb; Namenode和Datanode都正常启动&comma;但是web页面不显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jw3djq.html">Linux内核分析&mdash;&mdash;第七章  链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3l0eq.html">struts实现邮件发送功能</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93pp4zn8.html">JSP&mdash;&mdash;MVC模式&plus;Servlet生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7eero19.html">glsl 全屏 uv 旋转</a>
			</li>
						<li><a href="https://www.batexi.com/a/9533oez8.html">df命令&sol;du命令&sol;磁盘分区</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ee4mj9.html">Java中级面试题及答案整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/963316n9.html">Android开发学习笔记-自定义组合控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qveegg19.html">linux将标准输出和标准错误输出都重定向到一个文件&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjdmw28.html">转：Hibernate query&period;list&lpar;&rpar;之卡住问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4dnoxq.html">python &lowbar;&lowbar;all&lowbar;&lowbar;用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmej6l9.html">使用psutil库监控linux的系统资源和自定义进程的cpu 内存占用。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmej3g9.html">MTK 锁屏配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
